{
 "cells": [
  {
   "cell_type": "markdown",
   "id": "cd2c7322",
   "metadata": {},
   "source": [
    "# Тест по блоку #"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "f17e8ddf",
   "metadata": {},
   "source": [
    "1. Отметьте все исключения стандартной библиотеки Python\n",
    "\n",
    "- [ ] `RequestException`\n",
    "- [x] `IndexError`\n",
    "- [x] `ValueError`\n",
    "- [x] `KeyboardInterrupt`"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "111c86f4",
   "metadata": {},
   "source": [
    "2. Какие из методов генерации исключения разрешены в Python?\n",
    "\n",
    "- [x] `raise ValueError(\"error\")`\n",
    "- [ ] `raise None`\n",
    "- [ ] `raise \"ValueError\"`\n",
    "- [x] `raise ValueError`"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "c1818260",
   "metadata": {},
   "source": [
    "3. Обращение к несуществующему атрибуту экземпляра\n",
    "\n",
    "- [x] сгенерирует исключение `AttributeError`\n",
    "- [ ] вернет `False`\n",
    "- [ ] вернет `None`\n",
    "- [ ] сгенерирует исключение `KeyError`"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "b3b663ae",
   "metadata": {},
   "source": [
    "4. Отметьте верные утверждения про `classmethod`\n",
    "\n",
    "- [ ] Метод не принимает дополнительных аргументов кроме указанных программистом\n",
    "- [x] Метод первым аргументом принимает класс\n",
    "- [ ] Метод первым аргументом принимает ссылку на экземпляр класса\n",
    "- [x] К этому методу можно обращаться от имени класса\n",
    "- [x] К этому методу можно обращаться от экземпляра класса"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "83062bcf",
   "metadata": {},
   "source": [
    "5. Отметьте верные утверждения про `staticmethod`\n",
    "\n",
    "- [ ] Метод первым аргументом принимает ссылку на экземпляр класса\n",
    "- [ ] Метод первым аргументом принимает класс\n",
    "- [x] К этому методу можно обращаться от имени класса\n",
    "- [x] Метод не принимает дополнительных аргументов кроме указанных программистом\n",
    "- [x] К этому методу можно обращаться от экземпляра класса"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "de052315",
   "metadata": {},
   "source": [
    "6. Для чего используются `@property`?\n",
    "\n",
    "- [ ] Чтобы делать методы приватными\n",
    "- [ ] Чтобы делать атрибуты приватными\n",
    "- [x] Чтобы создать вычисляемый атрибут"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "12760f65",
   "metadata": {},
   "source": [
    "7. Если имя метода в классе начинается с символа нижнего подчеркивания, например: `_get_name`\n",
    "\n",
    "- [ ] символ нижнего подчеркивания в начале метода не добавляет никакого дополнительного значения\n",
    "- [ ] если вызвать метод у экземпляра класса, то сгенерируется исключение `AttributeError`\n",
    "- [x] обращаться к методу объекта не рекомендуется, так как метод не считается публичным API класса"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "b60a0d44",
   "metadata": {},
   "source": [
    "8. Можно ли использовать экземпляры классов в качестве ключей словаря (`dict`)?\n",
    "\n",
    "- [x] Да\n",
    "- [ ] Нет"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "a25fe512",
   "metadata": {},
   "source": [
    "9. Можно ли передавать экземпляр класса как аргумент в функцию?\n",
    "\n",
    "- [x] Да\n",
    "- [ ] Нет"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "6d084df3",
   "metadata": {},
   "source": [
    "10. Предположим есть базовый класс питомец - `Pet` и класс наследник - `Cat`. Отметьте варианты, которые вернут `True`\n",
    "\n",
    "- [x] `issubclass(Cat, Pet)`\n",
    "- [x] `isinstance(Cat(), Cat)`\n",
    "- [x] `issubclass(Cat, object)`\n",
    "- [x] `isinstance(Cat(), Pet)`\n",
    "- [ ] `issubclass(Pet, Cat)`"
   ]
  }
 ],
 "metadata": {
  "kernelspec": {
   "display_name": "Python 3",
   "language": "python",
   "name": "python3"
  },
  "language_info": {
   "codemirror_mode": {
    "name": "ipython",
    "version": 3
   },
   "file_extension": ".py",
   "mimetype": "text/x-python",
   "name": "python",
   "nbconvert_exporter": "python",
   "pygments_lexer": "ipython3",
   "version": "3.6.8"
  }
 },
 "nbformat": 4,
 "nbformat_minor": 5
}
